<!--
  ~ Benchmarking Suite
  ~ Copyright 2014-2022 Engineering Ingegneria Informatica S.p.A.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~ http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<template>

    <v-expansion-panel>
      <v-expansion-panel-header disable-icon-rotate>
        <CommonHeader
          :subtitle="(seq+1) + '. ' + toolName + ':' + workloadName+' @ ' + runParams"
          nobg
        />
        <template v-slot:actions>
          <v-icon color="error" v-if="globalStatus!=0">
            mdi-alert-circle
          </v-icon>
          <v-icon color="teal" v-if="globalStatus==0">
            mdi-check
          </v-icon>
        </template>
      </v-expansion-panel-header>

    <v-expansion-panel-content>

      <v-container style="width:100%">
        <CommonHeader
          xsubtitle="Workload"
        />
        <v-row>
          <v-col cols="4">
            <div class="esy-label">Workload</div> {{workloadName}}
          </v-col>
          <v-col cols="4">
            <div class="esy-label" v-if="toolName">Tool</div> {{toolName}}
          </v-col>
          <v-col cols="4">
            <div class="esy-label">Status</div>
            <span :class="status" style="border-radius:5px; padding:5px; font-weight:bold">{{status}}</span>
          </v-col>
        </v-row>

        <!--
        <CommonHeader
          xsubtitle="Host"
        />
        <v-row>
          <v-col cols="4">
            <div class="esy-label">Image</div> {{flavour}}
          </v-col>
          <v-col cols="2">
            <div class="esy-label">Size</div> {{size}}
          </v-col>
          <v-col cols="2">
            <div class="esy-label">CPU</div> {{cpu}}
          </v-col>
          <v-col cols="2">
            <div class="esy-label">RAM</div> {{memory}}
          </v-col>
          <v-col cols="2">
            <div class="esy-label">Disk</div> {{disk}}
          </v-col>
        </v-row>
        -->

        <CommonHeader
          subtitle="Metrics"
        />

        <div style="padding:10px">
          <div class="esy-label">Metrics</div>
          <v-data-table
            :headers="resultsHeaders"
            :items="resultsValues"
            :sort-by="['metric']"
            hide-default-footer
            class="elevation-1"
          ></v-data-table>
        </div>

        <CommonHeader
          subtitle="Command Line"
        />

        <v-row>
          <v-col>
            <div class="esy-label">Bash CLI&nbsp;<Tip :text="cliTip"/></div>{{cli}}</v-col>
        </v-row>

        <CommonHeader
          subtitle="Logs"
        />
        <v-tabs grow v-model="active_tab">
          <v-tab v-for="tab of tabs" :key="tab">
            {{tab}}
            <v-icon color="error" v-if="stepExecuted(tab) && stepStatus(tab) != 0">
              mdi-alert-circle
            </v-icon>
            <v-icon color="teal" v-if="stepExecuted(tab) && stepStatus(tab) == 0">
              mdi-check
            </v-icon>
            <v-icon color="gray" v-if="!stepExecuted(tab)">
              mdi-fast-forward-outline
            </v-icon>
          </v-tab>
        </v-tabs>

        <v-tabs-items v-model="active_tab">
          <v-tab-item v-for="tab of tabs" :key="tab">
            <div v-if="run.status.steps[tabs[active_tab].toLowerCase()]">
              <v-row v-if="exception">
                <v-col cols="12">
                  <div class="esy-label">Exception</div> <div v-html="exception" class="console-err"></div>
                </v-col>
              </v-row>
              <v-row v-if="traceback">
                <v-col cols="12">
                  <div class="esy-label">Traceback</div> <div v-html="traceback" class="console-err"></div>
                </v-col>
              </v-row>

              <!-- TODO: stdout and stderr can be multiple (one for each component in the run object). Make Tabs also here -->
              <v-row>
                <v-col cols="12">
                  <div class="esy-label">Stdout</div> <div v-html="stdout" class="console"></div>
                </v-col>
              </v-row>
              <v-row>
                <v-col cols="12">
                  <div class="esy-label">Stderr</div> <div v-html="stderr" class="console-err"></div>
                </v-col>
              </v-row>

              <v-row>
                <v-col cols="12">
                  <div class="esy-label">Executor Logs</div> <div v-html="execLogs" class="console"></div>
                </v-col>
              </v-row>
            </div>
            <div v-else>
              <i>Not Executed</i>
            </div>

          </v-tab-item>
        </v-tabs-items>


      </v-container>

    </v-expansion-panel-content>

  </v-expansion-panel>


</template>

<script>

import CommonHeader from '../common/CommonHeader.vue';

import { buildResponse } from './executions.js';
import Tip from '../common/Tip.vue';
import { mapGetters } from "vuex";

export default {

  name: 'RunViewer',

 components: {
    CommonHeader,
    Tip
  },

  props: {
    run: {
      type: Object,
      default: function() {return {}}
    },
    seq: {
      type: Number,
      default: 0
    }
  },

  data () {
      return {
        active_tab: 2,
        tabs: ['Provision', 'Setup', 'Prepare', 'Run', 'Collect', 'Cleanup', 'Deprovision'],
        resultsHeaders: [
          {
            text: 'Metric',
            align: 'start',
            value: 'metric',
          },
          { text: 'Value', value: 'value' , align: 'end'},
          { text: 'Unit', value: 'unit' , align: 'start'}
        ]
      }
  },

  computed: {
    ...mapGetters(["getProfile"]),
    resultsValues: function() {
      var out = [];
      for(var k in this.run.status.metrics) {
        var o = this.run.status.metrics[k];
        out.push({metric:k, value:o.value, unit:o.unit});
      }
      return out;
    },
    sectionTitle: function() {
      return this.workloadName+"\non "+this.flavour+" ("+this.size+")"
    },
    workloadName: function() {
      return this.run.workload.name
    },
    toolName: function() {
      return this.run.workload.tool
    },
    runParams: function() {
      return this.run.status?.sut_nodes;
    },

    globalStatus: function() {
      for (const value of Object.values(this.run.status.steps)) {
        if(value.errno != 0) {
          // TODO: we only catch the error satus of one step
          return value.errno
        }
      }
      return 0
    },
    cli: function() {
      return `bsctl -vvv session create --workload db://${this.run.workload.id} --provider db://${this.run.provider.id} --play-now --skip-store`
    },
    cliTip: function() {
      return `Make sure following environment is configured:<br/> - BS_DB_REQUESTOR=${this.getProfile.preferred_username}<br/> - BS_DB_AES_KEY=&lt;db secret key&gt;`
    },
    status: function() {
      if(this.globalStatus == 0){
        return 'SUCCESS'
      }
      else {
        return 'FAILED'
      }
    },
    flavour: function() {
      return this.run.provider.image;
    },
    size: function() {
      return this.run.provider.size;
    },
    disk: function() {
      return "n/a"
      /*
      if(this.run.results)
        return this.run.results.execution.environment.vms[0].disk + " GB";
      else
        if(this.run.errors && this.run.errors.exec_env && this.run.errors.exec_env.vms)
          return this.run.errors.exec_env.vms[0].disk + " GB";
        else
          return "n/a"
      */
    },
    memory: function() {
      return "n/a"
      /*
      if(this.run.results)
        return this.run.results.execution.environment.vms[0].memory + " MB";
      else
        if(this.run.errors && this.run.errors.exec_env && this.run.errors.exec_env.vms)
          return this.run.errors.exec_env.vms[0].memory + " MB";
        else
          return "n/a"
      */
    },
    cpu: function() {
      return "n/a"
      /*
      if(this.run.results)
        return this.run.results.execution.environment.vms[0].cpu;
      else
        if(this.run.errors && this.run.errors.exec_env && this.run.errors.exec_env.vms)
          return this.run.errors.exec_env.vms[0].cpu;
        else
          return "n/a"
      */
    },

    execLogs: function() {
      let active_step = this.tabs[this.active_tab].toLowerCase()
      let job = this.run.status.steps[active_step]
      var res = ""
      if(job && job.logs){
        res = job.logs.join('\n')
      }
      return buildResponse(res, "Executor Logs")
    },

    stdout: function() {
      let active_step = this.tabs[this.active_tab].toLowerCase()
      let job = this.run.status.steps[active_step]
      var res = ""
      if (job && job.components) {
        // get the first job. TODO: make tabs to show multiple components if exists
        let job_name = Object.keys(job.components)[0];
        res = job.components[job_name]['stdout']
      }
      return buildResponse(res, "Stdout")
    },

    stderr: function() {
      let active_step = this.tabs[this.active_tab].toLowerCase()
      let job = this.run.status.steps[active_step]
      var res = ""
      if (job && job.components) {
        // get the first job. TODO: make tabs to show multiple components if exists
        let job_name = Object.keys(job.components)[0];
        res = job.components[job_name]['stderr']
      }
      return buildResponse(res, "Stderr")
    },

    traceback: function() {
      let active_step = this.tabs[this.active_tab].toLowerCase()
      let job = this.run.status.steps[active_step]
      var res = ""
      if(job && job.logs){
        res = job.traceback
      }
      return buildResponse(res, "Traceback")
    },

    exception: function() {
      let active_step = this.tabs[this.active_tab].toLowerCase()
      let job = this.run.status.steps[active_step]
      var res = ""
      if(job && job.logs){
        res = job.exception
      }
      return buildResponse(res, "Exception")
    }

    /*
    _exitStatus: function() {
      if(this.run.errors && this.run.errors.exception_data && this.run.errors.exception_data.exit_status)
          return this.run.errors.exception_data.exit_status;
      else
        return "";
    },
    cmd: function() {
      if(this.run.errors && this.run.errors.exception_data && this.run.errors.exception_data.cmd)
          return this.run.errors.exception_data.cmd.replace(/\n/g, '<br/>');
      else
        return "";
    },
    phase: function() {
      if(this.run.errors && this.run.errors.phase)
          return this.run.errors.phase;
      else
        return "";
    }
    */
  },
  methods: {
    stepExecuted: function(name) {
      // consider exectued if it has a start time
      return this.run.status.steps[name.toLowerCase()].start
    },
    stepStatus: function(name) {
      return this.run.status.steps[name.toLowerCase()].errno
    }
  }
};

</script>

<style>

  .console, .console-err {
    overflow:auto;
    white-space:nowrap;

    font-family:monospace;
    font-size:8pt;
    background:#404040;
    padding:10px;
    color:white
  }

  .console-err {
    color:orange
  }

</style>
